// $Id: bzv.js 1664 2009-07-14 11:36:31Z anton $
// $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-6.1.0/html/static/bzv.js $
//
// Provide the XMLHttpRequest class for IE 5.x-6.x:
// RESOURCE = http://en.wikipedia.org/wiki/XMLHttpRequest
if( typeof XMLHttpRequest == "undefined" ) XMLHttpRequest = function() {
  try { return new ActiveXObject("Msxml2.XMLHTTP.6.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP.3.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP") } catch(e) {}
  try { return new ActiveXObject("Microsoft.XMLHTTP") } catch(e) {}
  throw new Error( "This browser does not support XMLHttpRequest." )
};


/*
More information from http://www.w3.org/TR/XMLHttpRequest/
*/

var INDEPOT = "In depot: ";

function extractData(xmlDoc,tagFilter) {
    var rootNode = xmlDoc.documentElement;

    var records = rootNode.childNodes;
    var numRecords = records.length;
    var data = new Array();

    for(var i = 0; i < numRecords; i++) {
	var record = records[i];
	if(!record.tagName || record.tagName != tagFilter)
	    continue;

	var datum = new Object();
	var fields = record.childNodes;
	var numFields = fields.length;
	for(var j = 0; j < numFields; j++) {
	    var field = fields[j];
	    if(!field.tagName)
		continue;

	    if(field.childNodes && field.childNodes[0])
		datum[field.tagName] = field.childNodes[0].nodeValue;
	}
	data.push(datum);
    }
    return data;
}

function createLinkDiv( url, displayText, imageBoolean  )
{
    var divNode = document.createElement("div");
    // YAHOO.util.Dom.addClass(divNode, "depot");

    if (imageBoolean){
	var imageNode = document.createElement("img");
	imageNode.setAttribute("src", "/files/edoc.gif");
	imageNode.setAttribute("alt", "*");
	divNode.appendChild(imageNode);
    }
    var linkNode = document.createElement("a");
    linkNode.setAttribute("href", url);
    linkNode.setAttribute("target", "_blank");
    linkNode.appendChild(document.createTextNode(displayText));
    divNode.appendChild(linkNode);
    return divNode;
}

function translate(key )
{
    var translate =
	 { 'linkMethod': 'Journal',
	   'inLibrary':  'In library',
	   'inDepot':    'In depot',
	   'moreInfo':   'More information',
	   'showDetails': '&gt;',
	   'hideDetails': '&lt;',
	   //'showDetails': 'Show details',
	   //'hideDetails': 'Hide details',
	 };

    return translate[key];
}


function presentOpenUrls(node, o, openurl) {
    var data = extractData(o.responseXML,'record');
    var query = openurl.split("?")[1];
    var pairs = query.split("&");
    var genre = ""
    for (var i=0; i < pairs.length; i++) {
        var pair = pairs[i].split("=");
        if (pair[0] == "genre") {
            genre = pair[1];
        }
    }

    var lijst = new Array ('linkMethod','inLibrary','inDepot','moreInfo');
    var nodeHash = new Array ();
    for ( var el in lijst ){
	nodeHash[lijst[el]] =  new Array ();
    }

    for(var key in data) {
	var datum = data[key];
	var url = datum.generatedUrl;

        if (genre == "article"){
            if(!url || url.indexOf('://') == -1) {
		var col = datum.collection;
		// FIXME: config
		// Moet overeenkomen met availability.sf
                if (col == "ECO" || col == "JUR" || col == "SOC" || col == "LET" || col == "CIF" || col == "TFL" || col == "BRA" || col == "GES" || col == "DISC"){
		    nodeHash['inLibrary'].push(document.createTextNode(datum.callNumber));
		}
		else if (col) {
		    // test met:
		    // ?recordId=RePEc-kap-pubcho:oai:RePEc:kap:pubcho:v:110:y:2002:i:3-4:p:327-50
		    var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=tucat&searchField=sgn&query=" + datum.callNumber;
		    nodeHash['inDepot'].push(createLinkDiv( url, datum.callNumber, false));
                }
            }
            else {
		nodeHash['linkMethod'].push(createLinkDiv(url, datum.linkMethod, true ));
            }
        }
        else {
            if (datum.callNumber) {
                //liNode.appendChild(document.createTextNode("More information about "));
                var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=tucat&searchField=sgn&query=" + datum.callNumber;
		nodeHash['moreInfo'].push(createLinkDiv( url, datum.callNumber, false));
            }
        }
    }

    for ( var el in lijst ){
	var group = lijst[el];
	if ( nodeHash[group].length > 0 ){
	    var titleNode = document.createElement("li");
	    YAHOO.util.Dom.addClass(titleNode, "title");
	    titleNode.appendChild(document.createTextNode(translate(group)));
	    node.appendChild(titleNode);

	    for ( var link in  nodeHash[group] ){
		var liNode = document.createElement("li");
		liNode.appendChild( nodeHash[group][link] );
		node.appendChild(liNode);
	    }
	}
    }

}

function openurl(nodeid, url){
    var node = document.getElementById(nodeid);

    function successHandler(o) {
	presentOpenUrls(node, o, url);
    }

    function failureHandler(o)
    {
	if (console)
	    console.log('Meresco:openurl XMLHttpRequest statusText: ' + o.statusText );

	node.appendChild(document.createTextNode("Locator unavailable"));
    }

    var request = YAHOO.util.Connect.asyncRequest('GET', url, {
	    success:successHandler,
	    failure:failureHandler,
	    timeout: 15000
	});
};

function getElementsByClass(node,searchClass,tag) {
    var classElements = new Array();
    var els = node.getElementsByTagName(tag); // use "*" for all elements
    var elsLen = els.length;
    var i, j;
    for (i = 0, j = 0; i < elsLen; i++) {
         if (els[i].className == searchClass) {
             classElements[j] = els[i];
             j++;
         }
    }
    return classElements;
}

function presentAvailability(node, o, location, inDepot, genre) {
    var status = o.responseXML.getElementsByTagName("dlf:availabilitystatus");
    var db = ""
    if (genre == "journal") {
         db = "tuts"
    }
    else {
         db = "tucat"
    }
    if (status.length > 0){
        availability = status[0].childNodes[0].nodeValue;
	var liNode = document.createElement("li");
        if (availability == 'available'){
            if (inDepot == 1){
		liNode.appendChild(createDepotDiv( db, INDEPOT, location));
            }
            else{
	        var out = "In the LIBRARY: " + location;
		liNode.appendChild(document.createTextNode(out));
            }
        }
        else{
	    liNode.appendChild(document.createTextNode("Not available. "));
	    var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db + "&searchField=sgn&query=" +
	          location;
	    var linkNode = document.createElement("a");
	    linkNode.setAttribute("href", url);
	    linkNode.setAttribute("target", "_blank");
	    text = "Availability information on " + location;
	    linkNode.appendChild(document.createTextNode(text));
	    liNode.appendChild(linkNode);
        }
	node.appendChild(liNode);
    }
}

function availability(nodeid, location, inDepot, genre, locator){
    var node = document.getElementById(nodeid);

    function successHandler(o) {
        presentAvailability(node, o, location, inDepot, genre);
    }

    function failureHandler(o)
    {
	if (console)
	    console.log('Meresco:availability XMLHttpRequest statusText: ' + o.statusText );

	node.appendChild(document.createTextNode("No availability information"));
    }

    var url = locator;
    var request = YAHOO.util.Connect.asyncRequest('GET', url, {
	    success:successHandler,
	    failure:failureHandler,
	    timeout: 15000
	});
};

// searchForm stuff
function relocateKeepDrilldown(  drilldown){
    var searchQuery = document.getElementById('searchQuery');
    var newLocation = "?query=" + searchQuery.value;

    if (drilldown){
	newLocation += drilldown;
    }
    top.location= newLocation;
    return false;
}

function relocateKeepQuery( obj ){
    var searchQuery = getElementById('searchQuery');
    var newQuery = "?query=" + searchQuery.value;
    var newLocation = newQuery + '&' + obj.value ;
    top.location= newLocation;
}

function relocateKeepQueryHref( query ){
    var searchQuery = document.getElementById('searchQuery');
    var newQuery = "?query=" + searchQuery.value;
    var newLocation = newQuery + '&' + query
    top.location= newLocation;
    return false;
}

function clearSearch(){
    var l=top.location;
    var port=l.port;
    if (l.port)
	port=":"+port;

    top.location=l.protocol + "//" + l.hostname + l.pathname + port;
}


// YAHOO stuff
modules  = new Array();

function clone(node) {
    var tagName = node.tagName;
    var nodeValue = node.nodeValue;

    if(tagName) {
	var cln = document.createElement(tagName);

	var att = node.attributes;
	for(var i = 0; i < att.length; i++)
	    cln.setAttribute(att[i].name, att[i].value);

	var chi = node.childNodes;
	for(var i = 0; i < chi.length; i++)
	    cln.appendChild(clone(chi[i]));

	return cln;
    } else if(nodeValue) {
	return document.createTextNode(nodeValue);
    }
}


function extractRecord(xmlDoc) {
    var rootNode = xmlDoc.documentElement;

    if(rootNode.nodeName=='parsererror') {
	if (console)
	    console.error( rootNode.firstChild.nodeValue);
    	//debugger;
    }

    var data = new Array();
    var fields = rootNode.childNodes;

    for(var i = 0; i < fields.length; i++ ) {
        var field = fields[i];

        if(!field.tagName || field.tagName != 'field')
            continue;

	var datum = new Object();

        var fieldElements = field.childNodes;
        for(var j = 0; j < fieldElements.length; j++ ) {
            var fieldElement = fieldElements[j];
	    var tagName = fieldElement.tagName;

           if(!tagName)
                continue;

            if(tagName == 'label')
		datum.label = fieldElement.childNodes[0].nodeValue;
	    else
		datum.content = fieldElement;
        }
	data.push(datum);
    }
    return data;
}

function presentData(dataArray, widget, index) {
    var tableNode = document.getElementById('table'+index);
    // Cleanup previous results
    while (tableNode.firstChild) {
	tableNode.removeChild(tableNode.firstChild);
    }

    // DO NOT use e.setAttribute("class", "classname");
    // because IE will ignore the call comletely.
    // In stead use:
    // YAHOO.util.Dom.addClass(tableNode, "recordElementTable");

    // For IE 'tbody' is required
    var tBodyNode  = document.createElement('tbody');
    YAHOO.util.Dom.addClass(tBodyNode, "recordElementTableBody");

    for(var i = 0; i < dataArray.length ; i++) {
        var field =              dataArray[i];
        var rowNode =            document.createElement('tr');
        var thLabelNode =        document.createElement('th');
        var tdContentNode =      document.createElement('td');

	thLabelNode.appendChild(document.createTextNode(field.label));
	rowNode.appendChild(thLabelNode);

	var childNodes = field.content.childNodes;
	for(var j = 0; j < childNodes.length; j++) {
	    if(childNodes[j]) {
		var chi = clone(childNodes[j]);
		tdContentNode.appendChild(chi);
	    }
	}
	rowNode.appendChild(tdContentNode);
	tBodyNode.appendChild(rowNode);
	tableNode.appendChild(tBodyNode);

	// IE Cannot handle the next line, even if it is made conditional.
	//if (console)
	//    console.log ( "classname is: " + YAHOO.util.Dom.get('recordElementLabel-'+index).className);

    }
}

function getContent(widget,recordId,index)
{
    function successHandler(o) {
        var data = extractRecord(o.responseXML);
        presentData(data, widget, index);
    }

    function failureHandler(o) {
        if (console)
            console.log('Meresco:openurl XMLHttpRequest statusText: ' + o.statusText );

        var widgetNode=document.getElementById("content"+index);
	// Fixme:  moet dit addClass worden?
        widgetNode.setAttribute("class","recordElementContentError");
        widget.setBody("Record information could not be retrieved: "+o.statusText);
    }

    var request = YAHOO.util.Connect.asyncRequest('GET',"/record?recordId="+recordId, {
            success:successHandler,
            failure:failureHandler,
            timeout: 15000
        });
}

function generateMoreinfoToggler(index, buttonPreName, recordId){
    var more = translate("showDetails");
    var less = translate("hideDetails");

    YAHOO.util.Event.onDOMReady(function () {
            modules[index]=new Array();
            modules[index].button =
                new YAHOO.widget.Button({ type: "checkbox",
					  label: more,
					  id: "checkbutton"+index, name: "checkboxfield"+index,
					  value: "1",
					  container: "moduleContainer"+index, checked: false });

            modules[index].widget=new YAHOO.widget.Module("content"+index, { visible: false });
            modules[index].widget.render();

            function onCheckedChange(e) {
                if (e.newValue) {
                    modules[index].button.set('label',less);
                    getContent(modules[index].widget,recordId,index );
                    modules[index].widget.show();
                } else {
                    modules[index].widget.hide();
                    modules[index].button.set('label',more);
                }
                modules[index].widget.render();
            }
            modules[index].button.addListener("checkedChange", onCheckedChange);

	});
}

// YAHOO stuff end
